<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        form {
            border      : 1px solid #ddd;
            padding     : 5px;
            width       : 225px;
            background  : #efefef;
        }

        label {
            display     : block;
            margin-top  : 5px;
        }

        input, textarea, select, option {
            min-width   : 200px;
        }
    </style>
</head>
<body>

    <div id="app">
        <form @submit.prevent="submitForm()">
            <p v-if="errors.length">
                <b>Please correct the following errors: </b>
                <ul>
                    <li v-for="error in errors">{{ error }}</li>
                </ul>
            </p>
            <label>Name: </label>
            <input type="text" :disabled="buttonStatus == 'upload'" name="name" ref="name" v-model="name">
            <label>Phone: </label>
            <input type="text" :disabled="buttonStatus == 'upload'" name="phone" ref="phone" v-model="phone">
            <label>Address: </label>
            <textarea :disabled="buttonStatus == 'upload'" name="address" ref="address" v-model="address"></textarea>
            <div v-if="buttonStatus == 'submit'">
                <input type="submit" value="SUBMIT">
            </div>
            <div v-else-if="buttonStatus == 'update'">
                <input type="button" value="UPDATE" @click="updateMember(idEditMember)">
                <input type="button" value="CANCEL" @click="clearForm(true)" style="margin-top:5px">
            </div>
            <div v-else-if="buttonStatus == 'upload'">
                <input type="file" name="photo" ref="photo">
                <input type="button" value="UPLOAD" @click="submitPhoto(idUpload)" style="margin-top: 5px">
                <input type="button" value="CANCEL" @click="clearForm(true)" style="margin-top:5px">
            </div>
        </form>

        <br><br>
    
        <table border="1">
            <tr v-for="member in members">
                <td>
                    <img width="100" :src="member.photo_profile ? photoDomain + member.photo_profile : 'https://dummyimage.com/16:9x1080'" alt="">
                </td>
                <td>
                    <b>Name : </b> {{ member.name }} <br>
                    <b>Phone : </b> {{ member.no_hp }} <br>
                    <b>Address : </b> {{ member.address }} <br>
                </td>
                <td>
                    <button @click="editMember(member)">Edit</button>
                    <button @click="deleteMember(member.id)">Hapus</button>
                    <button @click="uploadPhoto(member)">Upload Foto</button>
                </td>
            </tr>
        </table>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
    var vm = new Vue({
        el: '#app',
        data: {
            name        : '',
            phone       : '',
            address     : '',
            photoDomain : 'http://demo-api-vue.sanbercloud.com',
            buttonStatus: 'submit',
            idEditMember: null,
            idUpload    : null,
            errors      : [],
            members     : []
        },
        methods: {
            validationForm  : function () {
                this.errors = []

                if (this.name.length < 3) {
                    this.errors.push('Gunakan nama lengkap anda!')
                    this.$refs.name.focus()
                }

                if (this.phone.length < 8) {
                    this.errors.push('Nomor Telepon minimal 8 digit')
                    this.$refs.phone.focus()
                }

                if (this.address.trim().length == 0) {
                    this.errors.push('Alamat tidak boleh kosong')
                    this.$refs.address.focus()
                }
            },
            clearForm       : function (bool = false) {
                this.name = ''
                this.phone = ''
                this.address = ''
                if (bool == true) {
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                    this.idUpload = null
                }
            },
            submitForm      : function () {
                this.validationForm()

                if (this.errors.length === 0) {
                    let formData = new FormData()
                    formData.append('name', this.name)
                    formData.append('address', this.address)
                    formData.append('no_hp', this.phone)

                    const config = {
                        method  : "post",
                        url     : "http://demo-api-vue.sanbercloud.com/api/member",
                        data    : formData
                    }

                    axios(config)
                        .then( (response) => {
                            this.clearForm()
                            this.getMembersData()
                            alert(response.data.message)
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                }
            },
            getMembersData  : function () {
                const config = {
                    method  : "get",
                    url     : "http://demo-api-vue.sanbercloud.com/api/member"
                }

                axios(config)
                    .then( (response) => {
                        this.members = response.data.members
                    })
                    .catch( (error) => {
                        console.log(error)
                    })
            },
            deleteMember    : function (id) {
                const config = {
                    method : "post",
                    url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                    params : { _method : "DELETE" }
                }

                axios(config)
                    .then( (response) => {
                        this.getMembersData()
                        alert(response.data.message)
                    })
                    .catch( (error) => {
                        console.log(error)
                    })
            },
            editMember      : function (member) {
                this.name = member.name
                this.phone = member.no_hp
                this.address = member.address
                this.idEditMember = member.id
                this.buttonStatus = 'update'
            },
            updateMember    : function (id) {
                this.validationForm()

                if (this.errors.length === 0) {
                    let formData = new FormData()
                    formData.append('name', this.name)
                    formData.append('address', this.address)
                    formData.append('no_hp', this.phone)

                    const config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params : { _method : "PUT" },
                        data : formData
                    }

                    axios(config)
                        .then( (response) =>{
                            this.clearForm(true)
                            this.getMembersData()
                            alert(response.data.message)
                        })
                        .catch( (error) => {
                            console.log(error)
                        })
                }
            },
            uploadPhoto     : function (member) {
                this.name = member.name
                this.phone = member.no_hp
                this.address = member.address
                this.idUpload = member.id
                this.buttonStatus = 'upload'
            },
            submitPhoto     : function (id) {
                let file = this.$refs.photo.files[0]
                let formData = new FormData()
                formData.append('photo_profile', file)

                const config = {
                    method : "post",
                    url : `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                    data : formData
                }

                axios(config)
                    .then( (response) => {
                        this.clearForm(true)
                        this.getMembersData()
                        alert(response.data.message)
                    })
                    .catch( (error) => {
                        console.log(error)
                    })
            }
        },
        created () {
            this.getMembersData()
        },
    })
    </script>

</body>
</html>